/**
 * AutoDAO - Generic DAO on steroids implementation for Java.
 * Copyright (C) 2008  Marat Radchenko <slonopotamus@users.sourceforge.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.autodao;

import java.lang.reflect.Method;

/**
 * Exception that is throws when AutoDAO interface violates any rules.
 * This exception indicates programming error, it should never be caught.
 * NOT FOR PUBLIC USE.
 */
public final class SpecificationViolationException extends RuntimeException {

  /**
   * Constructor.
   * @param message error message.
   * @param meth    invalid method.
   */
  public SpecificationViolationException(final String message, final Method meth) {
    this(message, meth, null);
  }

  public SpecificationViolationException(final String message, final Method meth, final Throwable cause) {
    super("AutoDAO specification violation in " + meth + ": " + message, cause);
  }
}
